from urllib.parse import parse_qs, urlparse


def get_val_from_url_by_query_key(url: str, query_key: str) -> str:
    """
    从url的query参数中解析出query_key对应的值
    :param url: url地址
    :param query_key: query参数的key
    :return:
    """
    url_res = urlparse(url)
    url_query = parse_qs(url_res.query, keep_blank_values=True)

    try:
        query_val = url_query[query_key][0]
    except KeyError:
        raise KeyError(f"url 中不存在 {query_key} 参数")

    if len(query_val) == 0:
        raise ValueError(f"url 中 {query_key} 参数值为空")

    return query_val
